#!/usr/bin/env python

# Author : Praneeth Bodduluri (lifeeth [at] gmail.com)
# Based on script from Chris' Python Page
# (http://homepage.hispeed.ch/py430/python/)
###########################################################################
# configure these paths:
LOGFILE = '/var/log/firewallauth.log'
PIDFILE = '/var/run/firewallauth.pid'

# and let USERPROG be the main function of your project
import firewallauth
USERPROG = firewallauth.login
###########################################################################

import sys, os
import ConfigParser


class Log:
    """file like for writes with auto flush after each write
    to ensure that everything is logged, even during an
    unexpected exit."""
    def __init__(self, f):
        self.f = f
    def write(self, s):
        self.f.write(s)
        self.f.flush()

def main():
    #change to data directory if needed
    os.chdir("/etc/firewallauthiitk")
    #redirect outputs to a logfile
    sys.stdout = sys.stderr = Log(open(LOGFILE, 'a+'))
    config = ConfigParser.RawConfigParser()
    config.read('config.cfg')
    username = config.get('Main', 'username')
    password = config.get('Main', 'password')
    #ensure the that the daemon runs a normal user
    # TODO
    # os.setegid(103)     #set group first "pydaemon"
    # os.seteuid(103)     #set user "pydaemon"
    #start the user program here:
    USERPROG(username,password)

if __name__ == "__main__":
    # do the UNIX double-fork magic, see Stevens' "Advanced
    # Programming in the UNIX Environment" for details (ISBN 0201563177)
    try:
        pid = os.fork()
        if pid > 0:
            # exit first parent
            sys.exit(0)
    except OSError, e:
        print >>sys.stderr, "fork #1 failed: %d (%s)" % (e.errno, e.strerror)
        sys.exit(1)

    # decouple from parent environment
    os.chdir("/")   #don't prevent unmounting....
    os.setsid()
    os.umask(0)

    # do second fork
    try:
        pid = os.fork()
        if pid > 0:
            # exit from second parent, print eventual PID before
            #print "Daemon PID %d" % pid
            open(PIDFILE,'w').write("%d"%pid)
            sys.exit(0)
    except OSError, e:
        print >>sys.stderr, "fork #2 failed: %d (%s)" % (e.errno, e.strerror)
        sys.exit(1)

    # start the daemon main loop
    main()

